'use strict';

/**
 * Removes elements from the end of an array until the passed function returns true,
 * Returns the remaining elements in the array.
 */
function dropRightWhile(arr, func) {
  var rightIndex = arr.length;

  while (rightIndex-- && !func(arr[rightIndex])) {
  }

  return arr.slice(0, rightIndex + 1);
}

module.exports = dropRightWhile;
