import './get_tag.js';
import isObject from './is_object.js';
import isArray from './is_array.js';

function reduce(src, func) {
  var i = 0;
  var acc = arguments[2];

  if (isArray(src)) {
    if (arguments.length !== 3) {
      acc = src[0];
    }

    while (i < src.length) {
      acc = func(acc, src[i], i, src);
      i += 1;
    }

    return acc;
  } else if (isObject(src)) {
    var keys = Object.keys(src);

    if (arguments.length !== 3) {
      acc = src[keys[0]];
    }

    while (i < keys.length) {
      var key = keys[i];
      acc = func(acc, src[key], key, src);
      i += 1;
    }

    return acc;
  }

  return acc;
}

export default reduce;
