'use strict';

require('./get_tag.js');
var is_object = require('./is_object.js');
var is_array = require('./is_array.js');

function reduce(src, func) {
  var i = 0;
  var acc = arguments[2];

  if (is_array(src)) {
    if (arguments.length !== 3) {
      acc = src[0];
    }

    while (i < src.length) {
      acc = func(acc, src[i], i, src);
      i += 1;
    }

    return acc;
  } else if (is_object(src)) {
    var keys = Object.keys(src);

    if (arguments.length !== 3) {
      acc = src[keys[0]];
    }

    while (i < keys.length) {
      var key = keys[i];
      acc = func(acc, src[key], key, src);
      i += 1;
    }

    return acc;
  }

  return acc;
}

module.exports = reduce;
